' Morsekeyer
' Sprache: Bascom-AVR-Basic Version 2.0.7.9 Demo/Freeware
'
' Hardware:
' Tastkontakte fuer Punkt und Strich an PB3 und PB2 (Tastung gegen Masse).
' Schaltausgang ist PB1. Tastung invertiert, Aktiv = 0V, Ruhe = 5V
' Poti zur Geschwindigkeitseinstellung an PB4


$regfile = "ATtiny13.dat"
$crystal = 1200000                                          ' Taktfrequenz: 1,2 MHz
$hwstack = 8                                                ' Platz fuer nur 4 Unterprogramme reserviert, spart SRAM
$swstack = 0                                                ' wird nicht gebraucht
$framesize = 0                                              ' dito

Dim I As Byte                                               ' wird in Zaehlschleife verwendet
Dim M As Byte                                               ' wird fuers Auslesen der Morsebits verwendet
Dim L As Byte                                               ' wird fuer niederwertigstes Bit von M verwendet
Dim Dit As Word                                             ' Laenge Punkt
Dim Dah As Word                                             ' Laenge Strich
Dim Wort As Word                                            ' Laenge Wortabstand
Dim P As Byte                                               ' Punktspeicher

Ddrb = &B0000_0010                                          ' Pin PB1 als Ausgang konfigurieren (1), Rest ist Eingang (0)
Portb = &B0000_1111                                         ' PB1 auf high, PullUp-Widerstaende fuer die Pins PB0, PB2 und PB3 aktivieren

Config Adc = Single , Prescaler = Auto                      ' AD- Konverter konfigurieren und starten
Start Adc


Do

    Start Adc
    Gosub Adclesen
    If Pinb.3 = 0 Then                                      ' Punktkontakt gedrueckt
        Portb.1 = 0                                         ' Schaltausgang ein (invertierte Logik)
        Waitms Dit
        Portb.1 = 1                                         ' Schaltausgang aus
        Waitms Dit
    End If

  Mark:

    If Pinb.2 = 0 Then                                      ' Strichkontakt gedrueckt
        Portb.1 = 0
        Waitms Dah
        If Pinb.3 = 0 Then                                  ' Punktkontakt zusaetzlich gedrueckt
            P = 1                                           ' Squeeze- bzw. Punktspeicher
        End If
        Portb.1 = 1
        Waitms Dit
        If P = 1 Then
            Portb.1 = 0
            Waitms Dit
            Portb.1 = 1
            Waitms Dit
            P = 0
            Goto Mark
        End If
    End If

Loop


Adclesen:

    Dit = Getadc(2)
    Dit = Dit + 416                                          ' fuer sinnvollen Einstellbereich der Geschwindigkeit
    Shift Dit, Right , 4                                     ' entspricht Teilung durch 16, spart Flash-Speicher
    Dah = 3 * Dit
    Wort = 8 * Dit
Return

End

